/**
 * Copyright (c) 2025 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#include "entity.h"
#include "assert/assert.h"
#include "input.h"

void playerInit(entity_t *ent) {
  assertNotNull(ent, "Entity cannot be NULL");

  printf("Initializing player entity\n");
}

void playerUpdate(entity_t *ent) {
  assertNotNull(ent, "Entity cannot be NULL");

  if(inputWasPressed(INPUT_RIGHT)) {
    entityMove(ent, FACING_DIRECTION_EAST);
  } else if(inputWasPressed(INPUT_LEFT)) {
    entityMove(ent, FACING_DIRECTION_WEST);
  } else if(inputWasPressed(INPUT_UP)) {
    entityMove(ent, FACING_DIRECTION_NORTH);
  } else if(inputWasPressed(INPUT_DOWN)) {
    entityMove(ent, FACING_DIRECTION_SOUTH);
  }
}